<?php

function devices_set_ota()
{
	$desc = "system failed";
    $file = "file";
    $server_domain = "/www/v1.0/srv_domain_file.unix";
    $file_save_dir = "/www/v1.0/devices/OTA/file/";
    
    $ret = 0;
    

	if($_FILES[$file]["error"] > 0){
		$ret = 1008;
		$desc = "_FILES error.";
        goto __failed;
	}else{
		$path = $_FILES[$file]["tmp_name"];
		$post_file_name = $_FILES[$file]["name"];
	}

	$md5_path = md5_file($path);
	
	$taskId = $_POST["taskId"];
	$md5 = $_POST["md5"];
	$devices_array = $_POST["devices"];
	
	if($md5_path !== $md5){
		$ret = 1007;
		$desc = "MD5 failed.";
        goto __failed;	
	}

	if($taskId == NULL || $md5 == NULL || $devices_array == NULL){
		$ret = 1006;
		$desc = "Params is null.";
        goto __failed;	
	}
/*
	$devs = json_decode($devices_array);

	if($devs == NULL || $devs == false){
		$ret = 1005;
		$desc = "Decode Json failed.";
        goto __failed;	
	}
*/
	copy($path,$file_save_dir . $post_file_name);
    

    //3 send message
	if (!($socket = socket_create(AF_UNIX, SOCK_STREAM, 0))){
        $ret = 1004;
        $desc = "socket_create error";
        goto __failed;
	}

    if((socket_connect($socket, $server_domain)) == FALSE){
    	$ret = 1005;
    	$desc = "socket_connect error";
        goto __close_sock;
    }
    //$mac = json_encode($devs->{'devices'});
    $mac = $devices_array;
    //$txt ="{\"devices\":$mac,\"file\":\"$file\",\"taskId\":\"$taskId\"}";
	$msg = "{\"cmd\":104,\"devices\":$mac,\"file\":\"$post_file_name\",\"taskId\":\"$taskId\"}";
	$len = strlen($msg);
	$bytes_sent = socket_send($socket, $msg, $len, MSG_DONTROUTE);

	if ($bytes_sent == FALSE){
		$ret = 1007;
		$desc = "socket_send error";
        goto __close_sock;
	}else if ($bytes_sent != $len){
        $ret = 1008;
        $desc = "socket_send error";
        goto __close_sock;
	}
	$time = 0;
	while(1){
		if($time > 20){
			$ret = 1009;
			$desc = "Timeout error";
        	goto __close_sock;
		}
		
		if (FALSE !== ($bytes=socket_recv($socket,$buf,1024,MSG_DONTWAIT))) {
	    	//echo "Read $bytes bytes from socket_read(): $buf <br>";

	    	$obj = json_decode($buf);

	    	if(NULL == $obj){
	    		$ret = 1010;
	    		$desc = "json_decode error";
	    		goto __close_sock;
	    	}

	    	if($obj->{'result'} == 0){
	    		
	    		devices_create_ota_task_file($mac,$taskId,$post_file_name);
	    		echo "{\"status\":\"0\",\"error\":\"0\",\"desc\":\"ok\"}";
	    	}else{
	    		$ret = 1011;
	    		$desc = "System Result:" . $obj->{'result'};
	    		goto __close_sock;
	    	}
	    
	    	break;
		} 

		sleep(1);
		$time++;
	}


	
    socket_close($socket);

    return;


__close_sock:
	socket_close($socket);
 __failed:	
 	http_response_code(500);
 	echo "{\"status\":\"1\",\"error\":\"$ret\",\"desc\":\"$desc\"}"; 
}  


function devices_create_ota_task_file($mac,$taskId,$file)
{
   
    $task_file = "/www/v1.0/devices/OTA/file/task";
    $myfile = fopen("$task_file", "w") or die("Unable to open file!");

    $txt ="{\"devices\":$mac,\"file\":\"$file\",\"taskId\":\"$taskId\"}";

    fwrite($myfile, $txt);
    
    fclose($myfile);
}

function devices_get_state()
{
	$task_file = "/www/v1.0/devices/OTA/file/task";
	$result_dir = "/www/v1.0/devices/OTA/devices/";
	$count = 0;

	if(file_exists($task_file)){
		$task_json = file_get_contents($task_file);
	}else{
		$ret = -1;
		$desc = "Task no exists";
		goto __failed;
	}

	$devs = json_decode($task_json);


	echo '{"status":"0","taskId":';
	echo json_encode($devs->{'taskId'});//$devs->{'taskId'};
	echo ',"devices":[';

	foreach ($devs->{'devices'} as $mac) { 
		if($count++ > 0){
			echo ",";
		}
    	if(file_exists($result_dir . $mac)){
			$state = file_get_contents($result_dir . $mac);
			if($state == 1){
				$state_string = "Success";
			}else{
				$state_string = "Failed";
			}
			echo "[\"$mac\",$state,\"$state_string\"]";
		}else{
			$state_string = "Woring";
			echo "[\"$mac\",0,\"$state_string\"]";
		}

    } 

    echo "]}";

    return;

__failed:
    http_response_code(500);
    echo "{\"status\":\"1\",\"error\":\"$ret\",\"desc\":\"$desc\"}";
}
?>