<?php
	require_once '/www/v1.0/devices/dev_read_group.php';
	require_once '/www/v1.0/common.php';
	
	$st_acss = get_station_access(); 
	$param_acss = $_GET["access"];

	if(strncmp($st_acss,$param_acss,strlen($st_acss)-1) != 0){
		echo "{\"status\":\"1\",\"error\":\"1\",\"desc\":\"Access failed\"}";
		return;
	}
	

	$file_b = "infor";
	$str_b = '100';
	$update_file_suffix = "devices/"; 
	$default_update_time_s = 3600;

	if(file_exists($file_b)){
		$str_b = file_get_contents($file_b);
		echo '{"status":"0",' . $str_b . '}';
		return ;
	}

	

	$file_name = dirname(__DIR__);
	$file_name_without_suffix = strstr($file_name,$update_file_suffix,false);
	$mac = substr($file_name_without_suffix, strlen($update_file_suffix));
	// echo "dir:",$file_name;
	// echo "<br>";
	// echo "sub:".$file_name_without_suffix;
	// echo "<br>";
	// echo "mac:".$mac;
	// echo "<br>";

	$ret = devices_read_group($mac);	

	
	if($ret != 0){
		return ;
	}

	$count = 0;

	while(1){
		if($count++ > 30){
			http_response_code(500);
			echo "{\"status\":\"1\",\"error\":\"-1\",\"desc\":\"read group  infor timeout\"}"; 
			break;
		}

		if(file_exists($file_b)){
			$str_b = file_get_contents($file_b);
			echo '{"status":"0",'  . $str_b . '}';
			break;
		}

		sleep(1);
	}
	

	
?>
