<?php

function station_set_bind($mac)
{
	$sSrc = "/www/v1.0/devices/device";
	$sTo = "/www/v1.0/devices/" . $mac;

	//echo "Src dir = $sSrc <br>";
	//echo "Dest dir = $sTo <br>";

    if("device" == $mac){
        $ret = 1001;
        $desc = 'Unsupport device';
        goto __failed;  
    }

	$ret = copyDir($sSrc,$sTo);

	if($ret == 0){
        $ab = 'a';
        $ab_mask = 1;
        station_create_index_file($mac,$ab,$ab_mask);
        $ab = 'b';
        $ab_mask = 2;
        station_create_index_file($mac,$ab,$ab_mask);
        $ab = 'ab';
        $ab_mask = 3;
        station_create_index_file($mac,$ab,$ab_mask);
		echo '{"status":"0"}';
		return;
	}else {
		$desc = 'System file opt failed.';
		goto __failed;
	}

 __failed:
 	http_response_code(500);
 	echo "{\"status\":\"1\",\"error\":\"$ret\",\"desc\":\"$desc\"}";  
}  

function station_create_index_file($mac,$ab,$ab_mask)
{
    $path = "/www/v1.0/devices/" . $mac . "/display_task/set_dis/" . "$ab" . "/index.php";
    //echo "path = $path <br>";

    $myfile = fopen("$path", "w") or die("Unable to open file!");

    $txt = "<?php\n";
    fwrite($myfile, $txt);

    $txt = "require_once '/www/v1.0/common.php';\n";
    fwrite($myfile, $txt);
    $txt = '$st_acss = get_station_access();';
    fwrite($myfile, $txt);
    $txt = "\n";
    fwrite($myfile, $txt);
    $txt = '$param_acss = $_POST["access"];';
    fwrite($myfile, $txt);
    $txt = "\n";
    fwrite($myfile, $txt);
    $txt = 'if(strncmp($st_acss,$param_acss,strlen($st_acss)-1) != 0){';
    fwrite($myfile, $txt);
    $txt = "\n";
    fwrite($myfile, $txt);
    $txt = 'echo "{\"status\":\"1\",\"error\":\"1\",\"desc\":\"Access failed\"}";';
    fwrite($myfile, $txt);
    $txt = "\n";
    fwrite($myfile, $txt);
    $txt = "return;\n";
    fwrite($myfile, $txt);
    $txt = "}\n";
    fwrite($myfile, $txt);

    $txt = "require_once '/www/v1.0/devices/dev_set_task.php';\n";
    fwrite($myfile, $txt);

    $txt = '$device' . " = \"$mac\";\n";
    fwrite($myfile, $txt);
    $txt = '$ab' . " = $ab_mask;\n";
    fwrite($myfile, $txt);
    $txt = 'devices_set_task($device,$ab);'. "\n";
    fwrite($myfile, $txt);
    $txt = "?>\n";
    fwrite($myfile, $txt);
    fclose($myfile);
}

function station_unbind($mac)
{
    $dir = "/www/v1.0/devices/" . $mac;

	//echo "dir = $dir <br>";
    if("device" == $mac){
        $ret = 1001;
        $desc = 'Unsupport device';
        goto __failed;  
    }

    if(!is_dir($dir)){
    	$ret = 1002;
        $desc = 'Directory not exist';
        goto __failed;
    }

    if(false == delTree($dir)){
        $ret = 1003;
        $desc = 'System file opt failed.';
        goto __failed;
    }else{
        echo '{"status":"0"}';
        return;
    }

 __failed:
    http_response_code(500);
    echo "{\"status\":\"1\",\"error\":\"$ret\",\"desc\":\"$desc\"}";  
} 

function delTree($dir) { 
    $files = array_diff(scandir($dir), array('.','..')); 

    foreach ($files as $file) { 
        (is_dir("$dir/$file")) ? delTree("$dir/$file") : unlink("$dir/$file"); 
    } 

    return rmdir($dir); 
} 

function copyDir($dirSrc,$dirTo)
{
    if(is_file($dirTo))
    {
        //echo $dirTo . '这不是一个目录';
        return -1;
    }
    if(!file_exists($dirTo))
    {
    	//echo "Dest dir = $sSTo <br>";
        if(false == mkdir($dirTo,0777,true)){
        	return -2;
        }
    }

    if($handle=opendir($dirSrc))
    {
        while($filename=readdir($handle))
        {
            if($filename!='.' && $filename!='..')
            {
                $subsrcfile=$dirSrc . '/' . $filename;
                $subtofile=$dirTo . '/' . $filename;
                if(is_dir($subsrcfile))
                {
                    copyDir($subsrcfile,$subtofile);//再次递归调用copydir
                }
                if(is_file($subsrcfile))
                {
                    copy($subsrcfile,$subtofile);
                }
            }
        }
        closedir($handle);
    }

    return 0;
}
?>