<?php

function devices_read_group($device)
{
	$desc = "system failed";
    $file = "file";
    $server_domain = "/www/v1.0/srv_domain_file.unix";
    $ret = 0;
    

	if (!($socket = socket_create(AF_UNIX, SOCK_STREAM, 0))){
        $ret = 1004;
        goto __failed;
	}

    if((socket_connect($socket, $server_domain)) == FALSE){
    	$ret = 1005;
        goto __failed;
    }

	$msg = "{\"cmd\":103,\"mac\":\"$device\"}";
	$len = strlen($msg);
	$bytes_sent = socket_send($socket, $msg, $len, MSG_DONTROUTE);

	if ($bytes_sent == FALSE){
		$ret = 1007;
		$desc = "socket_send failed";
        goto __failed;
	}else if ($bytes_sent != $len){
        $ret = 1008;
        $desc = "socket_send data lenght failed";
        goto __failed;
	}
	$time = 0;
	while(1){
		if($time > 180){
			$ret = 1009;
			$desc = "Wait timeout failed";
        	goto __failed;
		}
		
		if (FALSE !== ($bytes=socket_recv($socket,$buf,1024,MSG_DONTWAIT))) {
	    	//echo "Read $bytes bytes from socket_read(): $buf <br>";

	    	$obj = json_decode($buf);

	    	if(NULL == $obj){
	    		$ret = 1010;
	    		$desc = "json_decode failed";
	    		goto __close_sock;
	    	}

	    	if($obj->{'result'} == 0){
	    		//echo "{\"status\":\"0\",\"error\":\"0\",\"desc\":\"ok\"}";
	    		break;
	    	}else{
	    		$ret = 1011;
	    		$desc = "result failed";
	    		goto __close_sock;
	    	}
	    
	    	break;
		} 

		sleep(1);
		$time++;
	}


	
    socket_close($socket);

    return 0;


__close_sock:
	socket_close($socket);
 __failed:
 	http_response_code(500);
 	echo "{\"status\":\"1\",\"error\":\"$ret\",\"desc\":\"$desc\"}"; 
 	return  $ret;
}  

?>