<?php

function station_update_file()
{
	$desc = "system failed";
    $file = "file";
    $server_domain = "/www/v1.0/srv_domain_file.unix";
    $ret = 0;
    $update_dir = "/work/upgrade/";
    $update_file_suffix = ".tar.gz";
    
	if($_FILES[$file]["error"] > 0){
		$ret = 1006;
		$desc = "File error";
        goto __failed;
	}else{
		$path = $_FILES[$file]["tmp_name"];
	}

	$md5_path = md5_file($path);
	$md5 = $_POST["md5"];
	
	if($md5_path !== $md5){
		$ret = 1006;
		$desc = "MD5  error";
        goto __failed;	
	}

	$file_name = $_FILES["file"]["name"];
	// $file_name_without_suffix = strstr($file_name,$update_file_suffix,true);
	// //echo $file_name_without_suffix;
	// if(station_create_dir($update_dir .$file_name_without_suffix)){
	// 	$ret = 1006;
 //        goto __failed;
	// }

	//$cmd = "tar -zxvf " . $path . " -C " . $update_dir . $file_name_without_suffix;
	//echo $cmd;
	//sprintf(,"tar -zxvf %s/%s%s -C %s/%s",UPGRADE_DIR,file_name,UPGRADE_FILE_SUFFIX,UPGRADE_DIR,file_name);

	//$shell_cmd = system($cmd,$shell_val);
	move_uploaded_file($_FILES["file"]["tmp_name"], $update_dir . $file_name);

	if (!($socket = socket_create(AF_UNIX, SOCK_STREAM, 0))){
        $ret = 1004;
        $desc = "socket_create error";
        goto __failed;
	}

    if((socket_connect($socket, $server_domain)) == FALSE){
    	$ret = 1005;
    	$desc = "socket_connect error";
        goto __failed;
    }

	$msg = "{\"cmd\":14,\"file\":\"$file_name\"}";
	$len = strlen($msg);
	$bytes_sent = socket_send($socket, $msg, $len, MSG_DONTROUTE);

	if ($bytes_sent == FALSE){
		$ret = 1007;
		$desc = "socket_send error";
        goto __failed;
	}else if ($bytes_sent != $len){
        $ret = 1008;
        $desc = "socket_send error";
        goto __failed;
	}
	$time = 0;
	while(1){
		if($time > 120){
			$ret = 1009;
			$desc = "Timeout error";
        	goto __failed;
		}
		
		if (FALSE !== ($bytes=socket_recv($socket,$buf,1024,MSG_DONTWAIT))) {
	    	//echo "Read $bytes bytes from socket_read(): $buf <br>";

	    	$obj = json_decode($buf);

	    	if(NULL == $obj){
	    		$desc = "json_decode error";
	    		$ret = 1010;
	    		goto __close_sock;
	    	}

	    	if($obj->{'result'} == 0){
	    		echo "{\"status\":\"0\",\"error\":\"0\",\"desc\":\"ok\"}";
	    	}else{
	    		$ret = 1011;
	    		$desc = "System Result:" . $obj->{'result'};
	    		goto __close_sock;
	    	}
	    
	    	break;
		} 

		sleep(1);
		$time++;
	}


	
    socket_close($socket);

    return;


__close_sock:
	socket_close($socket);
 __failed:
 	http_response_code(500);
 	echo "{\"status\":\"1\",\"error\":\"$ret\",\"desc\":\"$desc\"}";  
}  

function station_create_dir($dir)
{
    if(is_file($dir)){
        //echo $dirTo . '这不是一个目录';
        return -1;
    }

    if(!file_exists($dir)){
    	//echo "Dest dir = $sSTo <br>";
        if(false == mkdir($dir,0777,true)){
        	return -2;
        }
    }

    return 0;
}

?>